//  The employee class
//
//  Includes (most) information about an employee.  The data fields
//  are protected from modification by the application.

class Empl {
    char fname[20], lname[20];
    float salary;
  public:
    Empl();			// Default constructor
    Empl(char *fn, char *ln);	// Additional constructor
    ~Empl();			// Destructor
    void Print();
    void Update(float sal);
    void Update(float sal, char *newtitle);
    void Update(char *fn, char *ln);

    // Returns the new salary value
    float Raise(float percent)	{ return (salary *= percent); }

    //	Functions to set the values of the data fields
    //    The strncpy() relies on all fields being zero'd by the
    //    constructor.
    void SetSalary(float sal)	{ salary = sal; }
    void SetFname(char *fn)	{ strncpy(fname, fn, sizeof(fname)-1); }
    void SetLname(char *ln)	{ strncpy(lname, ln, sizeof(lname)-1); }
    void SetSsn(char *s)	{ strncpy(ssn, s, sizeof(ssn)-1); }
    void SetTitle(char *t)	{ strncpy(title, t, sizeof(title)-1); }
    void SetGroup(char *grp)	{ strncpy(group, grp, sizeof(group)-1); }

    //	Functions to retrieve the data fields' values.
    const float GetSalary()		{ return salary; }
    const char* GetFname()		{ return fname; }
    const char* GetLname()		{ return lname; }
    const char* GetSsn()		{ return ssn; }
    const char* GetTitle()		{ return title; }
    const char* GetGroup()		{ return group; }
};

class Cler : public Empl {
    char skills[40];	// Skill list
    int wpm;		// Typing speed
  public:
    // Note the call to the Empl constructor.  In this case, it's
    // not required, but to call a base class non-default constructor
    // you need to use the ": Empl(...)" syntax WHERE THE FUNCTION IS
    // DEFINED!  Not in the declaration, but in the definition.
    Cler() : Empl() {
	memset(skills, 0, sizeof(skills));
	wpm = -1;
    }
    // It doesn't appear here (look in the source file) because this
    // is a declaration only.
    Cler(char *fn, char *ln);
    ~Cler()			{ }
    void Print();		// Needed in order to print the new fields!

    // Define the functions for Get()ing and Set()ing the new fields.
    void SetSkills(char *sk)	{ strncpy(skills, sk, sizeof(skills)-1); }
    void SetSpeed(int speed)	{ wpm = speed; }

    char* GetSkills()		{ return skills; }
    int   GetSpeed()		{ return wpm; }
};

class Tech : public Empl {
  public:
    enum schooling {
	None=0,
	HighSchool=1,
	College2yr=2, Associate=2,
	College4yr=3, Bachelor=3,
	College6yr=4, Master=4,
	College8yr=5, Doctorate=5
    };
    Tech() : Empl()		{ memset(type, 0, sizeof(type)); educ = 0; }
    Tech(char *fn, char *ln);
    ~Tech()			{ }
    void Print();		// Needed in order to print the new fields!

    // Define the functions for Get()ing and Set()ing the new fields.
    void SetType(char *ty)	{ strncpy(type, ty, sizeof(type)-1); }
    void SetEduc(int ed)	{ educ = ed; }

    char* GetType()		{ return type; }
    char* GetEduc();
  private:
    char type[10];		// Category
    enum schooling educ;	// Amount of education
};
